Subject: Chairs review of <draft-ietf-6man-ra-pref64-04>

From: Bob Hinden <[email-masked]>
Date: Thu, 29 Aug 2019 13:38:56 -0700

Jen, Lorenzo,

Our review is below.

Thanks,
Bob & Ole

> IPv6 Maintenance                                              L. Colitti
> Internet-Draft                                                J. Linkova
> Intended status: Standards Track                                  Google
> Expires: February 12, 2020                               August 11, 2019
> 
> 
>              Discovering PREF64 in Router Advertisements
>                      draft-ietf-6man-ra-pref64-04
> 
> Abstract
> 
>   This document specifies a Router Advertisement option to communicate
>   NAT64 prefixes to clients.
> 
> 

.  . . .

> 1.  Introduction
> 
>   NAT64 [RFC6146] with DNS64 [RFC6147] is a widely-deployed mechanism
>   to provide IPv4 access on IPv6-only networks.  In various scenarios,
>   the host must be aware of the NAT64 prefix in use by the network.
>   This document specifies a Router Advertisement [RFC4861] option to
>   communicate the NAT64 prefix to hosts.
> 
> 1.1.  Requirements Language
> 
>   The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
>   "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
>   document are to be interpreted as described in RFC 2119 [RFC2119].
> 
> 1.2.  Terminology
> 
>   Pref64 (or NAT64 prefix): an IPv6 prefix used for IPv6 address
>   synthesis [RFC6146];

s/Pref64/PREF64/  here and elsewhere.  This would be consistent with title and headers.

> 
>   NAT64: Network Address and Protocol Translation from IPv6 Clients to
>   IPv4 Servers ([RFC6146]);
> 

“(  )” are not needed.  Here and later.

>   RA: Router Advertisement, a message used by IPv6 routers to advertise
>   their presence together with various link and Internet parameters
>   ([RFC4861]);
> 
> 

. . . .

> 
>   DNS64: a mechanism for synthesizing AAAA records from A records
>   ([RFC6147]);
> 
> 2.  Use cases for communicating the NAT64 prefix to hosts
> 
>   On networks employing NAT64, it is useful for hosts to know the NAT64
>   prefix for several reasons, including the following:
> 
>   o  Local DNSSEC validation.  As discussed in [RFC6147] section 2, the

s/validation/validation (DNS64 in sub-resolver mode)/

>      stub resolver in the host "will try to obtain (real) AAAA RRs, and
>      in case they are not available, the DNS64 function will synthesize
>      AAAA RRs for internal usage."  This is required in order to use
>      DNSSEC on a NAT64 network.
> 
>   o  IPv4 address literals on an IPv6-only host.  As described in
>      [RFC8305] section 7.1, IPv6-only hosts connecting to IPv4 address
>      literals can resolve the IPv4 literal to an IPv6 address.
> 
>   o  464XLAT [RFC6877]. 464XLAT is widely deployed and requires that
>      the host be aware of the NAT64 prefix.

s/464XLAT is widely deployed and requires/464XLAT requires/

>   o  Trusted DNS server.  AAAA synthesis is required for the host to be
>      able to use a DNS server not provided by the network (e.g., a DNS-
>      over-TLS server ([RFC7858]) with which the host has an existing
>      trust relationship).
> 
>   o  Networks with no DNS64 server.  Hosts that support AAAA synthesis
>      and that are aware of the NAT64 prefix in use do not need the
>      network to perform the DNS64 function at all.

Also, could the distinction be made clearer about which is to configure NAT64 and which to configure DNS64?

> 
> 3.  Why include the NAT64 prefix in Router Advertisements
> 
>   Fate sharing: NAT64 requires a routing to be configured.  IPv6

s/requires a routing/requires routing/

>   routing configuration requires receiving an IPv6 Router Advertisement
>   [RFC4861].  Compared to currently-deployed NAT64 prefix discovery
>   methods such as [RFC7050], including the NAT64 prefix in the Router
>   Advertisement minimizes the number of packets required to configure a
>   host.  This speeds up the process of connecting to a network that
>   supports NAT64/DNS64, and simplifies host implementation by removing
>   the possibility that the host can have an incomplete layer 3
>   configuration (e.g., IPv6 addresses and prefixes, but no NAT64
>   prefix).

Not everything is the above paragraph is about fate sharing.   Suggest splitting it for clarity.

> 
>   Updatability: it is possible to change the NAT64 prefix at any time,
>   because when it changes, it is possible to notify hosts by sending a
>   new Router Advertisement.
> 
> 

. . . .

> 
>   Deployability: all IPv6 hosts and networks are required to support

s/support/support Neighbor Discovery/

>   [RFC4861].  Other options such as [RFC7225] require implementing
>   other protocols.
> 

Such as?   Suggest listing them.

Suggest saying that it’s easier to deploy because it’s simpler to extend an existing ND implementation, than implementing and supporting a new protocol.

> 4.  Semantics

Would “Usage Guidelines” or “Discussion” be better than “Semantics”?  This doesn’t seem like
"semantics” to us.

> 
>   To support prefix lengths defined in ([RFC6052]) this option contains
>   the prefix length field.  However as /96 prefix is considered to be
>   the most common use case, the prefix length field is optional and
>   only presents for non-/96 prefixes.  It allows to keep the option
>   length to a minimum (16 bytes) for the most common case and increase
>   it to 20 bytes for non-/96 prefixes only (see Section 5 below for

Is 20 bytes correct?  Seems like 24 octets.

Also s/bytes/octets/

>   more details).

[See comment in Section 5]

> 
>   This option specifies exactly one NAT64 prefix for all IPv4
>   destinations.  If the network operator desires to route different
>   parts of the IPv4 address space to different NAT64 devices, this can
>   be accomplished by routing more specifics of the NAT64 prefix to
>   those devices.  For example, if the operator would like to route
>   10.0.0.0/8 through NAT64 device A and the rest of the IPv4 space
>   through NAT64 device B, and the operator's NAT64 prefix is
>   2001:db8:a:b::/96, then the operator can route
>   2001:db8:a:b::a00:0/104 to NAT64 A and 2001:db8:a:b::/64 to NAT64 B.
> 
>   This option may appear more than once in a Router Advertisement (e.g.
>   in case of graceful renumbering the network from one NAT64 prefix to
>   another).  Host behaviour with regards to synthesizing IPv6 addresses
>   from IPv4 addresses SHOULD follow the recommendations given in
>   Section 3 of [RFC7050], limited to the NAT64 prefixes that have non-
>   zero lifetime.
> 
>   In a network (or a provisioning domain) that provides both IPv4 and
>   NAT64, it may be desirable for certain IPv4 addresses not to be
>   translated.  An example might be private address ranges that are
>   local to the network/provisioning domain and should not be reached
>   through the NAT64.  This type of configuration cannot be conveyed to
>   hosts using this option, or through other NAT64 prefix provisioning
>   mechanisms such as [RFC7050] or [RFC7225].  This problem does not
>   apply in IPv6-only networks, because in such networks, the host does
>   not have an IPv4 address and cannot reach any IPv4 destinations
>   without the NAT64.  The multihoming and multiple provisioning domains
>   scenarios are discussed in Section 7.
> 
> 5.  Option format
> 
> 
> Colitti & Linkova       Expires February 12, 2020               [Page 4]
> Internet-Draft Discovering PREF64 in Router Advertisements   August 2019
> 
> 
>      0                   1                   2                   3
>      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
>     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
>     |     Type      |    Length     |           Lifetime            |
>     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
>     |                                                               |
>     +                                                               +
>     |              Highest 96 bits of the Prefix                    |
>     +                                                               +
>     |                                                               |
>     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
>     | Lowest bits (96-127) of the prefix (optional, if Length > 2)  |
>     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
>     | Prefix Length |                  Reserved                     |
>     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
> 
> 

Would it be better to just use 8 bit prefix length and a 16 byte prefix field, like is done elsewhere in ND.  Why invent a new format?  This would simplify the format and be less complex.

> 
>                   Figure 1: NAT64 Prefix Option Format
> 
>   Fields:
> 
> 
> Colitti & Linkova       Expires February 12, 2020               [Page 5]
> Internet-Draft Discovering PREF64 in Router Advertisements   August 2019
> 
> 
>   Type     8-bit identifier of the Pref64 option type as assigned by
>            IANA: TBD
>   Length   8-bit unsigned integer.  The length of the option (including
>            the Type and Length fields) is in units of 8 octets. If the
>            prefix length is 96 bits the sender MUST set the Length to 2
>            and include the 96 bits of the prefix in the option. If the
>            prefix length is not 96 bits then the sender MUST set the
>            length to 3 and include all 128 bits of the prefix in the
>            Prefix field and set the Prefix Length field to the prefix
>            length.  The receiver MUST ignore the Pref64 option if the
>            length field value is 1. If the Length field value exceeds
>            3, the receiver MUST utilize the first 21 octets and ignore
>            the rest of the option.

Why not not ignore if Length > 3.  There are only two legitimate values, 2 and 3.

> 
>   Lifetime 16-bit unsigned integer.  The maximum time in seconds over
>            which this NAT64 prefix MAY be used. The value of Lifetime
>            SHOULD by default be set to lesser of  3 x MaxRtrAdvInterval
>            or 65535 seconds.  A value of zero means that the prefix
>            MUST no longer be used.
> 
>   Highest  96-bit unsigned integer. Contains bits 0 - 95 of the NAT64
>   96 bits  prefix.
>   of the
>   prefix
> 
> 
>   Lowest   32-bit unsigned integer. Contains bits 96 - 127 of the NAT64
>   bits of  prefix. This field is optional and presents only if the
>   the      prefix length is not 96 bits.
>   prefix

Perhaps add:  and the Length field is set to 3.

> 
>   Prefix   8-bit unsigned integer. Optional field which present only if
>   Length   the prefix length is not 96 bits. The sender MUST set it
>            only to one of the following values: 32, 40, 48, 56, 64
>            ([RFC6052]. The receiver MUST ignore the Pref64 option if
>            the prefix length value is not set to one of those numbers.
> 
>   Reserved A 3-byte unused field.  If present it MUST be initialized to
>            zero by the sender and MUST be ignored by the receiver. This
>            field is optional and presents only if the prefix length is
>            not 96 bits.
> 
> 6.  Handling Multiple NAT64 Prefixes
> 
>   In some cases a host may receive multiple NAT64 prefixes from
>   different sources.  Possible scenarios include (but are not limited
>   to):
> 
> 

. . . . .

> 
> 
>   Note that if the network provides Pref64 both via this RA option and
>   [RFC7225], hosts that receive the Pref64 via RA option may choose to
>   use it immediately before waiting for PCP to complete, and therefore
>   some traffic may not reflect any more detailed configuration provided
>   by PCP.
> 
> 7.  Multihoming

Is this section useful?  Could it be dropped.   Seems well beyond the scope of a new RA option.

> 
>   Like most IPv6 configuration information, the Pref64 option is
>   specific to the network on which it is received.  For example, a
>   Pref64 option received on a particular wireless network may not be
>   usable unless the traffic is also sourced on that network.
>   Similarly, a host connected to a cellular network that provides NAT64
>   generally cannot use that NAT64 for destinations reached through a
>   VPN tunnel that terminates outside that network.
> 
>   Thus, correct use of this option on a multihomed host generally
>   requires the host to support the concept of multiple Provisioning
>   Domains (PvD, a set of configuration information associated with a
>   network, [RFC7556]) and to be able to use these PvDs.
> 
> 

. . . . .

> 12.  References
> 
> 12.1.  Normative References
> 
>   [RFC2119]  Bradner, S., "Key words for use in RFCs to Indicate
>              Requirement Levels", BCP 14, RFC 2119,
>              DOI 10.17487/RFC2119, March 1997,
>              <https://www.rfc-editor.org/info/rfc2119>.
> 
>   [RFC4861]  Narten, T., Nordmark, E., Simpson, W., and H. Soliman,
>              "Neighbor Discovery for IP version 6 (IPv6)", RFC 4861,
>              DOI 10.17487/RFC4861, September 2007,
>              <https://www.rfc-editor.org/info/rfc4861>.
> 
>   [RFC6052]  Bao, C., Huitema, C., Bagnulo, M., Boucadair, M., and X.
>              Li, "IPv6 Addressing of IPv4/IPv6 Translators", RFC 6052,
>              DOI 10.17487/RFC6052, October 2010,
>              <https://www.rfc-editor.org/info/rfc6052>.
> 
> 12.2.  Informative References
> 
>   [I-D.ietf-intarea-provisioning-domains]
>              Pfister, P., Vyncke, E., Pauly, T., Schinazi, D., and W.
>              Shao, "Discovering Provisioning Domain Names and Data",
>              draft-ietf-intarea-provisioning-domains-05 (work in
>              progress), June 2019.
> 
>   [RFC4033]  Arends, R., Austein, R., Larson, M., Massey, D., and S.
>              Rose, "DNS Security Introduction and Requirements",
>              RFC 4033, DOI 10.17487/RFC4033, March 2005,
>              <https://www.rfc-editor.org/info/rfc4033>.
> 
> 
> 
> 
> Colitti & Linkova       Expires February 12, 2020               [Page 9]
> Internet-Draft Discovering PREF64 in Router Advertisements   August 2019
> 
> 
>   [RFC6105]  Levy-Abegnoli, E., Van de Velde, G., Popoviciu, C., and J.
>              Mohacsi, "IPv6 Router Advertisement Guard", RFC 6105,
>              DOI 10.17487/RFC6105, February 2011,
>              <https://www.rfc-editor.org/info/rfc6105>.
> 
>   [RFC6146]  Bagnulo, M., Matthews, P., and I. van Beijnum, "Stateful
>              NAT64: Network Address and Protocol Translation from IPv6
>              Clients to IPv4 Servers", RFC 6146, DOI 10.17487/RFC6146,
>              April 2011, <https://www.rfc-editor.org/info/rfc6146>.
> 
>   [RFC6147]  Bagnulo, M., Sullivan, A., Matthews, P., and I. van
>              Beijnum, "DNS64: DNS Extensions for Network Address
>              Translation from IPv6 Clients to IPv4 Servers", RFC 6147,
>              DOI 10.17487/RFC6147, April 2011,
>              <https://www.rfc-editor.org/info/rfc6147>.
> 
>   [RFC6877]  Mawatari, M., Kawashima, M., and C. Byrne, "464XLAT:
>              Combination of Stateful and Stateless Translation",
>              RFC 6877, DOI 10.17487/RFC6877, April 2013,
>              <https://www.rfc-editor.org/info/rfc6877>.
> 
>   [RFC7050]  Savolainen, T., Korhonen, J., and D. Wing, "Discovery of
>              the IPv6 Prefix Used for IPv6 Address Synthesis",
>              RFC 7050, DOI 10.17487/RFC7050, November 2013,
>              <https://www.rfc-editor.org/info/rfc7050>.

Should this be normative?

> 
>   [RFC7225]  Boucadair, M., "Discovering NAT64 IPv6 Prefixes Using the
>              Port Control Protocol (PCP)", RFC 7225,
>              DOI 10.17487/RFC7225, May 2014,
>              <https://www.rfc-editor.org/info/rfc7225>.
> 
>   [RFC7556]  Anipko, D., Ed., "Multiple Provisioning Domain
>              Architecture", RFC 7556, DOI 10.17487/RFC7556, June 2015,
>              <https://www.rfc-editor.org/info/rfc7556>.
> 
>   [RFC7858]  Hu, Z., Zhu, L., Heidemann, J., Mankin, A., Wessels, D.,
>              and P. Hoffman, "Specification for DNS over Transport
>              Layer Security (TLS)", RFC 7858, DOI 10.17487/RFC7858, May
>              2016, <https://www.rfc-editor.org/info/rfc7858>.
> 
>   [RFC8305]  Schinazi, D. and T. Pauly, "Happy Eyeballs Version 2:
>              Better Connectivity Using Concurrency", RFC 8305,
>              DOI 10.17487/RFC8305, December 2017,
>              <https://www.rfc-editor.org/info/rfc8305>.
> 
> 
> 
> 

. . . .

---

From: Mark Andrews <[email-masked]>
Date: Fri, 30 Aug 2019 10:00:56 +1000

As bits [64..71] MUST be zero just use.

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |     Type      |   Length (2)  |           Lifetime            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   | Prefix Length |   Prefix excluding bits [64..71]              |
   +-+-+-+-+-+-+-+-+                                               +
   |                                                               |           
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |   Suffix excluding bits [64..71]   (All zeros if not set)     |
   +                                                               +                                                            
   |                                                               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

-- 
Mark Andrews, ISC
1 Seymour St., Dundas Valley, NSW 2117, Australia
PHONE: +61 2 9871 4742              INTERNET: [email-masked]

---

From: Lorenzo Colitti <[email-masked]>
Date: Fri, 30 Aug 2019 09:40:12 +0900

Chairs,

Thanks for the review. Answers to non-trivial points inline.

> NAT64 and which to configure DNS64?

I'm not sure I understand this comment. This option communicates the NAT64
prefix. The prefix is needed/useful for the various things listed in that
section, including DNS64 validation, local DNS64 synthesis, etc. These have
in common the fact that they all need to know the prefix.

Would it help make things clearer if we added the following to the "trusted
DNS server" text?

====
In this case, local AAAA synthesis is needed because the server will likely
not be aware of which NAT64 prefix is in use on the network that the host
is connected to.
====

Or are you saying we need to group the use cases, such as the following?

====

   - Local DNS64 synthesis. As discussed in [RFC6147] section 2, the stub
   resolver in the host "will try to obtain (real) AAAA RRs, and in case they
   are not available, the DNS64 function will synthesize AAAA RRs for internal
   usage." This is useful in the following cases:
      - Local DNSSEC validation. If the host performs DNS64 synthesis
      itself, then the synthesized AAAA records can be trusted because the host
      has already validated the original A records.
      - Trusted DNS server.  AAAA synthesis is required for the host to
      be able to use a DNS server not provided by the network (e.g., a
      DNS-over-TLS server ([RFC7858]) with which the host has an existing trust
      relationship).
      - Networks with no DNS64 server.  Hosts that support AAAA synthesis
      and that are aware of the NAT64 prefix in use do not need the network to
      perform the DNS64 function at all.
      - IPv4 address literals on an IPv6-only host.  As described in
   RFC8305] section 7.1, IPv6-only hosts connecting to IPv4 address literals
   can resolve the IPv4 literal to an IPv6 address.
   - 464XLAT [RFC6877]. 464XLAT that the host be aware of the NAT64 prefix.

====

> Would it be better to just use 8 bit prefix length and a 16 byte prefix
> field, like is done elsewhere in ND.  Why invent a new format?  This would
> simplify the format and be less complex.
>

If I understand the question correctly, the format was chosen because in
the prefix is pretty much always 96 bits long, and in that case, the option
only consumes 16 bytes instead of 24 on the wire. Perhaps it's worth
writing this explicitly in the text? Something like:

====
In the common case of a /96 PREF64, this results in an option length of 2
bytes instead of the 3 that would be required if the prefix length were
always specified.
====

> Why not not ignore if Length > 3.  There are only two legitimate values, 2

That does make sense. Jen, do you recall why we wrote this? Was it to
preserve the ability to add more fields to the option in the future,
without breaking existing implementations?

> scope of a new RA option.

Personally I agree that it should be dropped. The text was added by the
request of the WG (specifically Nick Heatley, whom I've CCd). Others,
(IIRC, Mikael Abrahamsson) had already suggested that we remove it,
(correctly) pointing out that there is nothing special about this option
with regard to multihoming.

> Should this be normative?

Hmm. Probably yes, given that we say that if multiple prefixes are present
then the host needs to follow the text in that RFC.

Cheers,
Lorenzo

---

From: Jen Linkova <[email-masked]>
Date: Fri, 30 Aug 2019 13:06:45 +1000

> Thanks for the review. Answers to non-trivial points inline.

Oh while I was on the plane addressing the trivial comments some
discussion has happened on the list ;)

> I'm not sure I understand this comment. This option communicates the NAT64 prefix. The prefix is needed/useful for the various things listed in that section, including DNS64 validation, local DNS64 synthesis, etc. These have in common the fact that they all need to know the prefix.

I read this as a suggestion to split those use cases into two groups:
1) Allowing host to perform DNS64 functions (Local DNSSEC validation,
Trusted DNS server, networks w/o DNS64 at all)
2) allowing hosts to perform NAT64 address synthesis (464XLAT and IPv4
literals cases)

> That does make sense. Jen, do you recall why we wrote this? Was it to preserve the ability to add more fields to the option in the future, without breaking existing implementations?

Yes, exactly. If we explicitly mandate 'drop the option if Length > 3'
we would never be able to add anything later. So while 'drop'  does
not add any additional benefits it limits what we can do in the
future.

> Personally I agree that it should be dropped. The text was added by the request of the WG (specifically Nick Heatley, whom I've CCd). Others, (IIRC, Mikael Abrahamsson) had already suggested that we remove it, (correctly) pointing out that there is nothing special about this option with regard to multihoming.

I do not have a strong opinion here.  We can drop it unless the group
thinks otherwise.

-- 
SY, Jen Linkova aka Furry

---

From: Bob Hinden <[email-masked]>
Date: Thu, 29 Aug 2019 20:34:07 -0700

Lorenzo,

Breaking out the comment about the format:

> On Aug 29, 2019, at 5:40 PM, Lorenzo Colitti <[email-masked]> wrote:
> 
> 
> >
> >      0                   1                   2                   3
> If I understand the question correctly, the format was chosen because in the prefix is pretty much always 96 bits long, and in that case, the option only consumes 16 bytes instead of 24 on the wire. Perhaps it's worth writing this explicitly in the text? Something like:
> 
> ====
> In the common case of a /96 PREF64, this results in an option length of 2 bytes instead of the 3 that would be required if the prefix length were always specified.
> ====

We understand the reason for the format, we were asking if the resulting complexity of having essentially two different formats was worth the complexity.   It would make it simpler if there was just a prefix length and an address, like is done elsewhere in ND.   Is the saving in length work the extra complexity in the document and in implementations?

Bob

---

From: Lorenzo Colitti <[email-masked]>
Date: Fri, 30 Aug 2019 12:52:00 +0900

On Fri, Aug 30, 2019 at 12:34 PM Bob Hinden <[email-masked]> wrote:

> We understand the reason for the format, we were asking if the resulting
> complexity of having essentially two different formats was worth the
> complexity.   It would make it simpler if there was just a prefix length
> and an address, like is done elsewhere in ND.   Is the saving in length
> work the extra complexity in the document and in implementations?
>

Personally, I think so. It doesn't greatly complicate implementations -
it's just slightly complicating the parsing code. It's not making complex
behaviour changes which would complicate the state machine. I think the
space savings are worth it - the space in RAs is limited because we don't
allow fragmentation.

---

From: Jen Linkova <[email-masked]>
Date: Fri, 30 Aug 2019 13:59:10 +1000

On Fri, Aug 30, 2019 at 1:52 PM Lorenzo Colitti
<lorenzo=[email-masked]> wrote:
> Personally, I think so. It doesn't greatly complicate implementations - it's just slightly complicating the parsing code. It's not making complex behaviour changes which would complicate the state machine. I think the space savings are worth it - the space in RAs is limited because we don't allow fragmentation.

+1. There are pros and cons for both approaches but having another
format requires implementors to do some work *once* (I'm not an
implementor so I do not know how much work we are adding to their
plate by introducing the new format (adding David who has wrote some
code). But saving size might pay off in future...

---

From: Ole Troan <[email-masked]>
Date: Fri, 30 Aug 2019 08:54:53 +0200

Mark,

Given that the format in rfc6052 is ... for the lack of better words convoluted and unneccessary, I would prefer to conveniently ignore the U octet. The "routing around U" was never needed and it certainly isn't now with the deprecation of the U/G flags.
(Although a NAT64 implementation still needs to implement U octet support obviously)

It's nice with a simple implementation:
in6_addr_t nat64_prefix;
memcpy(&nat64_prefix, &packet->nat64_prefix, sizeof(nat64_prefix));

Cheers,
Ole

> On 30 Aug 2019, at 02:00, Mark Andrews <[email-masked]> wrote:
> 
> 
>>    0                   1                   2                   3
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------

---

From: Ole Troan <[email-masked]>
Date: Fri, 30 Aug 2019 09:04:45 +0200

Jen,

> 2) allowing hosts to perform NAT64 address synthesis (464XLAT and IPv4

Exactly.
Since the DNS and NAT functions got split after NAT-PT, it's good to be consistent and continue to treat them as separate functions.

Cheers,
Ole

---

From: Mark Andrews <[email-masked]>
Date: Fri, 30 Aug 2019 17:35:05 +1000

Well apart from /96 DNS64 implementations will set those bits to 0 to interoperate
and nameservers do reject prefixes with those bit set with /96 prefixes.

> On 30 Aug 2019, at 4:54 pm, Ole Troan <[email-masked]> wrote:
> 
> Mark,
>

---

From: Ole Troan <[email-masked]>
Date: Fri, 30 Aug 2019 10:09:21 +0200

> code). But saving size might pay off in future...

There is only going to be one of these options in a packet (most of the time).
Inventing a new prefix representation purely to save 8 bytes just doesn't seem worth it. Contrast that with the PIO option where 16 bytes are always used.

If we run out of space; a) split the RA into multiple packets b) that seems to be an indication that the RA mechanism is being misused.

Cheers,
Ole

---

From: Bob Hinden <[email-masked]>
Date: Fri, 30 Aug 2019 08:02:54 -0700

Jen,

> On Aug 29, 2019, at 8:06 PM, Jen Linkova <[email-masked]> wrote:
> 
> 

Sorry, what would you want to add in the future?   I didn’t read anything in the draft about future extendability.  It seems to me like this document does one thing.  Shouldn’t other things be done in different options?

Bob

---

From: Lorenzo Colitti <[email-masked]>
Date: Sat, 31 Aug 2019 16:20:11 +0900

On Fri, Aug 30, 2019 at 5:09 PM Ole Troan <[email-masked]> wrote:

> Inventing a new prefix representation purely to save 8 bytes just doesn't
> seem worth it. Contrast that with the PIO option where 16 bytes are always
> used.
>

Well, 8 bytes is a 50% increase.

If we run out of space; a) split the RA into multiple packets

Now that, on the other hand, *would* substantially complicate
implementations. Obviously, it would complicate router implementations,
which AFAIK support only one RA packet.

Hosts do have to deal with multiple RAs today, though I don't know how well
they actually do. But even if they do, splitting the RA impacts application
reliability due to non-atomic configuration. This is because in the common
case (yes, not guaranteed - but the common case is pretty much universal),
configuration via RA is atomic in the sense that only one packet is enough
to convey a complete L3 configuration to hosts. This is good. For an
example of why non-atomic configuration is bad, consider the following RAs:

   1. RA with PIO, RDNSS and default router.
   2. RA with PREF64.

There are two problems with this. First, there is a race condition between
the network stack and applications. As soon as the host receives RA #1, it
will think it's connected to an IPv6-only network. It will tell
applications that the network is connected. Unfortunately, applications
that need to talk to IPv4-only servers will fail until RA #2 arrives,
because synthesis cannot occur without knowing the NAT64 prefix. If the
network provides a DNS64 server, things go better... unless user-defined
DNS servers (e.g., a trusted DoT or DoH server) are in use, or the host
wants to do DNSSEC validation. In a world where DNSSEC is widely deployed,
this is either a hard failure or a window for a downgrade attack.

Second, a reliability problem. If RA #2 gets lost (which can happen), the
host is in limbo, with IPv4 applications similarly broken until the next
periodic multicast RA arrives. For a battery-powered host, that will be
several *minutes* if the network follows the best practices in RFC 7772.
Also, even if things go well on initial connect, the problem can occur
later on. If the host gets unlucky with packet loss, RA #2 could expire
before RA #1 expires. In that case, IPv4-only applications might stop
working again even though the host does not disconnect.

What can the stack do? Obviously, it *cannot* just wait until RA #2 arrives
because on a truly IPv6-only network (as opposed to an IPv6-only network
with NAT64), it will never arrive. It can retransmit RSes periodically
hoping that a pref64 will arrive, but that costs battery power, and, well,
implementations don't do this today (and based on previous conversations on
the list I don't think we even have consensus that the standard allows it).
That is what I meant in my earlier message about implementation complexity.
Compared with dealing with a problem like this, supporting both 16-byte and
24-byte option formats is absolutely trivial - it's basically just a couple
more lines of parsing code. Sure, you could say that it will be several
years before this becomes a problem, but if PVDs take off then RAs may get
a lot bigger and extra bytes will matter more than they do today.

So, again, my vote is to keep the smaller option format, and indeed, to
ensure that as we (6man) define new RA options, we don't waste space in the
RA.